/*
** Module   :SHOWTREE.CMD
** Abstract :Show basic list
**
** Copyright (C) Link Guard Solutions
**
** Log: Mon  19/03/2001 Created
**
*/

/* First parse parameters */
a = arg(1)

/*      Set default values */
knownword="PATH SHOWHIDDEN"
pars.path=''
pars.showhidden=''
addparams = '' /* This will hold 'additional params' to be passed to every other showtree call */

do while a<>''
    parse var a param'&'a
    parse var param pname'='pvalue
    pname = translate(pname)
    if wordpos(pname, knownword) = 0 then
        addparams = addparams||'&'||param
    else
	    pars.pname=pvalue
end
if pars.showhidden<>'' then
    addparams = addparams||'&showhidden=y'

/* Create list */
/* Print head */
ct = sf_get_config("settings", "contenttype")
if ct<>'' then ct = '; '||ct
say "Content-type: text/html"||ct
say "Pragma: no-cache"
say ""
say "<HTML><TITLE>SafeFire PPP Remote Control</TITLE><BODY>"
/* Print body */

/* Body start */
say '<h2>List of '||pars.path||' variables</h2>'
say '<p>'
if pars.path<>'' then do
    x = lastpos('.', pars.path)
    if x = 0 then
    do
        prevpath = ''
        prevname = 'Root'
    end
    else
    do
        prevpath = left(pars.path, x - 1)
        prevname = prevpath
    end
    say '<h3>Return to <a href="sfcgi.cmd?showtree&path='||prevpath||addparams||'">'||prevname||'</a></h3'
	say '<p>'
end

/* Print list */
call sf_localbase 'LIST', 'sfcgi.pipes.0.'pars.path, '::*', 'list.'
washidden = 0
do i = 1 to list.0
    parse var list.i id':'lang':'val
    if val = '' then val = id /* Strange, no '::' */
    val = reverse(x2c(d2x(val)))
    isubvar = bitand(left(val, 1), '01'x)<> '00'x
    iplugin = bitand(substr(val, 3, 1), '01'x)<> '00'x
    iname = bitand(left(val, 1), '02'x)<> '00'x
    ivalue = bitand(left(val, 1), '04'x)<> '00'x
    icomment = bitand(left(val, 1), '80'x)<> '00'x
    ihidden = bitand(left(val, 1), '20'x)<> '00'x
    ichangeable = bitand(left(val, 1), '08'x)<> '00'x
    ideleteable = bitand(left(val, 1), '10'x)<> '00'x
    nam = substr(list.i.name, 15) /*Strip sfcgi.pipes.0.*/
    if ihidden then
        washidden = 1
    if \ihidden | pars.showhidden<>'' then
    do
        if pars.path<>'' then
            parse var nam with (pars.path)relnam
        else
            relnam = nam
        if left(relnam, 1) = '.' then relnam = substr(relnam, 2)
        fulnam = relnam
        if iname then
        do
            call mylocalbase 'NAME', list.i.name, 'nm.'
            if nm.0 > 0 & translate(nm.1.name) = translate(list.i.name) & nm.1.type = 1 then
            do
                parse var nm.1 id':'lang':'fulnam
                if fulnam = '' then fulnam = id /* Strange, no '::' */
            end
        end
        if iplugin then say 'Plugin '
        if isubvar then
        do
            call charout ,'<a href="sfcgi.cmd?showtree&path='||nam||addparams||'">'
            if fulnam = '' then fulnam = '#'
        end
        call charout ,fulnam
        if isubvar then call charout ,'</a>'
        call charout ,'.'
        if ihidden then say '<font size=-1><sup>hidden</sup></font>'
        if ivalue then
        do
            call mylocalbase 'VALUE', list.i.name, 'nm.'
            if nm.0 > 0 & translate(nm.1.name) = translate(list.i.name) & nm.1.type = 1 then
            do
                parse var nm.1 id':'lang':'vval
                if vval = '' then vval = id /* Strange, no '::' */
                if vval<>'' then say " Value is <b>"||vval||"</b>."
            end
        end
        if ichangeable then
        do
            say ' <a href="sfcgi.cmd?setvalue&path='||nam||addparams||'&prevview=showtree">Set Value</a>'
        end
        if ideleteable then
        do
            say ' <a href="sfcgi.cmd?delvalue&path='||nam||addparams||'&prevview=showtree">Delete</a>'
        end
        if icomment then
        do
            call mylocalbase 'COMMENT', list.i.name, 'nm.'
            if nm.0 > 0 & translate(nm.1.name) = translate(list.i.name) & nm.1.type = 1 then
            do
                parse var nm.1 id':'lang':'vval
                if vval = '' then vval = id /* Strange, no '::' */
                if vval<>'' then say "(<i>"||vval||"</i>)"
            end
        end

        say "<p>"
    end
end

if washidden then
do
    say "Page contains hidden entries."
    if pars.showhidden<>'' then
        say '<A href="sfcgi.cmd?showtree&path='||pars.path||addparams||'&showhidden=">Hide them</a>.'
    else
        say '<A href="sfcgi.cmd?showtree&path='||pars.path||addparams||'&showhidden=y">Show them</a>.'
end
/* Print footer */
say "</BODY></HTML>"
return

mylocalbase:
/* This will strip second arg into "previous" and "name" and then call sf_local_base */
x = lastpos('.', arg(2))
if x = 0 then
do
    qname = ''
    qvalue = '::'||arg(2)
end
else
do
    qname = left(arg(2), x - 1)
    qvalue = '::'||substr(arg(2), x + 1)
end
call sf_localbase arg(1), qname, qvalue, arg(3)
return

